// Filename 		: LOADSAVE.H
// Coded by 		: Scott Evans
// Created/Modified : 21/7/98
// Description		: Load and save game routines


#ifndef _LOADSAVE_H_
#define _LOADSAVE_H_


#ifdef YAROZE

#include <libps.h>
#include <memcard.h>

#else

#endif


#include <stosspr.h>
#include <printfm.h>
#include "hscore.h"


// Size of the load/save buffer

#define LS_BUFFER_SIZE	1024

// Number of blocks used by file

#define LS_FILE_BLOCKS	1

		
// Game data to save

typedef struct
{
	u_word level_no;
	word sx,sy;
	u_word cheats_on;
	u_byte difficulty;
	u_byte lives;
	u_byte bombs;
	u_byte pad;	
}LSGAME_DATA;


u_byte SaveGame(u_byte);
u_byte LoadGame(u_byte);
void InitLSGameData(void);


#endif