COMPILER=ccpsx
PROJECT=bouncer
COPTS=-O3 -Id:\work\include -DNO_MALLOC -DPAL -DPSX -DNO_DEBUG -DREMOVE_PRINTF
LOPTS=-Xlinker -Ttext -Xlinker 80140000
LOBJS=../../lib/*.o
GOBJS=bouncer.o hscore.o menus.o backgrnd.o gobjects.o handlers.o anim.o message.o intro.o cheats.o	loadsave.o

all: $(GOBJS)
	psylink /le:\ps\lib /c @linkfile.lnk,$(PROJECT).cpe,$(PROJECT).sym,$(PROJECT).map

$(PROJECT).o: $(PROJECT).c $(PROJECT).h
        $(COMPILER) $(COPTS) -DDATA_INCLUDED -DRELEASE -c $(PROJECT).c -o $(PROJECT).o

hscore.o: hscore.c hscore.h 
	$(COMPILER) $(COPTS) -c hscore.c -o hscore.o

menus.o: menu.c menu.h 
	$(COMPILER) $(COPTS) -c menu.c -o menus.o 

backgrnd.o: backgrnd.c backgrnd.h 
	$(COMPILER) $(COPTS) -c backgrnd.c -o backgrnd.o

gobjects.o: gobjects.c gobjects.h 
	$(COMPILER) $(COPTS) -c gobjects.c -o gobjects.o

handlers.o: handlers.c handlers.h 
	$(COMPILER) $(COPTS) -c handlers.c -o handlers.o

anim.o: anim.c anim.h 
	$(COMPILER) $(COPTS) -c anim.c -o anim.o

message.o: message.c message.h 
	$(COMPILER) $(COPTS) -c message.c -o message.o

intro.o: intro.c intro.h
	$(COMPILER) $(COPTS) -c intro.c -o intro.o

cheats.o: cheats.c cheats.h
	$(COMPILER) $(COPTS) -c cheats.c -o cheats.o

loadsave.o: loadsave.c loadsave.h
	$(COMPILER) $(COPTS) -c loadsave.c -o loadsave.o

load:
        pqbload ..\sounds\bouncer2.vb 80100000
   
run:
	run $(PROJECT).cpe
		
aload:
	psexe -p1 -d80110000 ..\mapedit\levels
	psexe -p1 -d801144c4 ..\sounds\bouncer2.vh
	psexe -p1 -d80118ce4 ..\sounds\bouncer2.vb
	psexe -p1 -d80143754 ..\sprites\bfont
	psexe -p1 -d80145830 ..\sprites\sprites
	psexe -p1 -d80146dd4 ..\sprites\blocks
		
arun:
	cpe2x /CE $(PROJECT).cpe
	psexe -p1 $(PROJECT).exe
