// Filename 		: MENU.H
// Coded by 		: Scott Evans
// Created/Modified : 6/3/98
// Description		: B2 menu system


#ifndef _MENU_H_
#define _MENU_H_


#ifdef YAROZE
#include <libps.h>
#include <yaroze.h>
#endif


#include <mytypes.h>
#include <objects.h>
#include <mylib.h>
#include <font.h>
#include <sound.h>
#include <memcard.h>
#include <printfm.h>

#include "bouncer.h"
#include "message.h"
#include "cheats.h"


#define MAX_NO_MENUS		9
#define MAX_NO_MENU_ITEMS	5


enum
{
	MENU_TEXT_BRIGHTNESS,
	MENU_MIN_BRIGHTNESS,
	MENU_MAX_BRIGHTNESS,
	MENU_DISABLED_BRIGHTNESS=16
};


enum
{
	SM_LOAD,
	SM_SAVE,
	SM_FORMAT
};


enum
{
	MT_NONE=-1,
	MT_MAIN,
	MT_OPTIONS,
	MT_DIFFICULTY,
	MT_MCARD,
	MT_SMCARD,
	MT_PAUSE,
	MT_POPTIONS,
	MT_PDIFFICULTY,
	MT_PMCARD
};


typedef struct
{
	RECT area;
	u_word no_items;
	word menu_pos;
	word y_spacing;
	word previous;
	u_byte centre;
}MENU;


typedef struct
{
	u_byte *string;
	void (*f)(void);
	word next_menu;
	word active;
}MENU_ITEM;


OBJECT_STRING *CreateMenu(OBJECT_LIST_HEADER *,VECTOR *,u_word);
void ClearMenu(OBJECT_LIST_HEADER *);
void HideCurrentMenuItem(MENU *,OBJECT_STRING *,u_word);
void ShowCurrentMenuItem(MENU *,OBJECT_STRING *,u_word);
void StartMenuBouncing(OBJECT_LIST_HEADER *);
void HandleMenu(PROGRAM_DATA *,OBJECT_STRING *,u_word);
void HandleMenuObject(OBJECT *);
void HandleMenuExplosionFragment(OBJECT *);
void InitMenus(void);
void SortMenus(GsOT *,u_word);
void UpdateMenus(PROGRAM_DATA *);
void KillMenus(void);
void StartMenus(void);
void DisplayMenus(PROGRAM_DATA *,GsOT *,u_word);
void MenuPlayGame(void);
void MenuEasy(void);
void MenuMedium(void);
void MenuHard(void);
void MenuPositionScreen(void);
void SetCurrentMenu(u_word);
void MenuAboutB2(void);
void MenuInstructions(void);
void MenuSaveGame(void);
void MenuLoadGame(void);
void MenuMemoryCard1(void);
void MenuMemoryCard2(void);
void SetMemoryCardMessages(void);
void MenuFormatCard(void);
void MenuResumeGame(void);
void MenuExitGame(void);
void SetMenuObject(MENU *,OBJECT_STRING *,u_word,long);
void SetMemoryCardsMenu(long);


#endif
