// Filename 		: MESSAGE.H
// Coded by 		: Scott Evans
// Created/Modified : 13/6/98
// Description		: B2 message system


#ifndef _MESSAGE_H_
#define _MESSAGE_H_


#ifdef YAROZE

#include <libps.h>
#include <yaroze.h>

#else

#include <sys/types.h>
#include <kernel.h>
#include <libgte.h>
#include <libgpu.h>
#include <libgs.h>
#include <libetc.h>
#include <libsn.h>

#endif

#include <mytypes.h>
#include <objects.h>
#include <mylib.h>
#include <font.h>
#include <sound.h>
#include <printfm.h>

#include "bouncer.h"


#define MAX_PAGES				10
#define MAX_STRINGS_PER_PAGE	7


enum
{
	MOVE_SCREEN_MESSAGES,
	ABOUT_B2_MESSAGES,
	INSTRUCTION_MESSAGES,
	SAVEGAME_MESSAGES,
	LOADGAME_MESSAGES,
	SAVEPROGRESS_MESSAGES,
	LOADPROGRESS_MESSAGES,
	FORMAT_MESSAGES,
	FORMATPROGRESS_MESSAGES,
	EXITGAME_MESSAGES
};


void InitMessageSystem(void);
OBJECT_STRING *CreateTextPage(u_byte *[],RECT *,u_word *);
void HandleTextPageMessage(OBJECT *);
OBJECT_STRING *CreateMessages(u_word,word);
void ClearMessages(OBJECT_LIST_HEADER *);
void HandleMessageExplosionFragment(OBJECT *);
void DisplayMessages(GsOT *,u_word);
void KillMessages(void);
void StopMessage(OBJECT_STRING *);
void StartMessage(OBJECT_STRING *,u_word);
void SetMessagePosition(OBJECT_STRING *,BRIGHTNESS *b,word);


#endif