#ifndef _MAPEDIT_H_
#define _MAPEDIT_H_


#ifdef YAROZE
#include <libps.h>
#include <yaroze.h>
#endif

#include <mylib.h>
#include <stosspr.h>
#include <objects.h>
#include <sprites.h>
#include <vsync.h>
#include <fixedp.h>

#include "backgrnd.h"


#define MAX_MAP_SCREEN_ROWS	16
#define MAX_MAP_SCREEN_COLS	20
#define MAX_MAP_PACKETS		(MAX_MAP_SCREEN_ROWS*MAX_MAP_SCREEN_COLS)


#define OTLENGTH	1
#define MAXPKTS	(MAX_MAP_PACKETS+200)
#define PKTSIZE	24


#define SCRW	320

#ifdef PAL
#define SCRH	256
#else
#define SCRH	240
#endif


#define BUTTON_REPEAT_RATE 5
#define MAX_SPRITES	200
#define CLUT_X		(1024-16)
#define CLUT_Y 	0
#define TPAGE_X	SCRW
#define TPAGE_Y	0
#define SPRITE_ADDR	0x80090000
#define LEVEL_ADDR	0x80096000


typedef struct
{
	u_long id;
	LevelPblk pblock;
	byte data[MAX_MAP_ROWS*MAX_MAP_COLUMNS];
}LEVEL;


#endif
