// Filename 		: SPRMAP.H
// Coded by 		: Scott Evans
// Created/Modified : 1/3/98
// Description		: Locations of sprites in sprite bank


#ifndef _SPRMAP_H_
#define _SPRMAP_H_


enum
{
	FIRST_MAP_BLOCK_SPRITE,
	FIRST_INDUSTRUCTIBLE_BLOCK=0,								// 0
	LAST_INDUSTRUCTIBLE_BLOCK=FIRST_INDUSTRUCTIBLE_BLOCK+7,		// 7
	FIRST_DESTRUCTIBLE_MAP_BLOCK,								// 8
	NUMBER_NORMAL_MAP_BLOCKS=39,								
	FIRST_EFFECTS_BLOCK=FIRST_DESTRUCTIBLE_MAP_BLOCK+NUMBER_NORMAL_MAP_BLOCKS,		// 47
	EXPLOSION_MAP_BLOCK=FIRST_EFFECTS_BLOCK,					// 47
	FIREBALL_LEFT_MAP_BLOCK,									// 48
	FIREBALL_RIGHT_MAP_BLOCK,									// 49
	FIREBALL_DOWN_MAP_BLOCK,									// 50
	FIREBALL_UP_MAP_BLOCK,										// 51
	EXPLODE_GUNS_MAP_BLOCK,										// 52
	EXPLODE_PLATFORMS_MAP_BLOCK,								// 53
	UP_ARROW_MAP_BLOCK,											// 54
	DOWN_ARROW_MAP_BLOCK,										// 55
	EXPANDING_MAP_BLOCK,										// 56
	TELEPORT_MAP_BLOCK,											// 57
	REVERSE_CONTROLS_MAP_BLOCK,									// 58
	INVISIBLE_BLOKE_MAP_BLOCK,									// 59
	SUPER_BLOKE_MAP_BLOCK,										// 60
	SPLIT_BLOKE_MAP_BLOCK,										// 61
	RANDOM_EFFECT_MAP_BLOCK,									// 62
	EXTRA_LIFE_MAP_BLOCK,										// 63
	EXTRA_BOMB_MAP_BLOCK,										// 64
	EXTRA_TIME_MAP_BLOCK,										// 65
	EXIT_MAP_BLOCK,												// 66
	_4_HIT_MAP_BLOCK,											// 67
	_3_HIT_MAP_BLOCK,											// 68
	_2_HIT_MAP_BLOCK,											// 69
	_1_HIT_MAP_BLOCK,											// 70
	FIRST_DIAMOND_MAP_BLOCK,									// 71
	LAST_DIAMOND_MAP_BLOCK=FIRST_DIAMOND_MAP_BLOCK+6,			// 77
	LAST_DESTRUCTIBLE_MAP_BLOCK=LAST_DIAMOND_MAP_BLOCK,			// 77
	MOVING_PLATFORM_LEFT_MAP_BLOCK,								// 78
	MOVING_PLATFORM_RIGHT_MAP_BLOCK,							// 79
	GUN_FACING_LEFT_MAP_BLOCK,									// 80
	GUN_FACING_RIGHT_MAP_BLOCK=GUN_FACING_LEFT_MAP_BLOCK+3,		// 83
	FAN_FACING_UP_MAP_BLOCK=GUN_FACING_RIGHT_MAP_BLOCK+3,		// 86
	FAN_FACING_DOWN_MAP_BLOCK=FAN_FACING_UP_MAP_BLOCK+5,		// 91
	FAN_FACING_LEFT_MAP_BLOCK=FAN_FACING_DOWN_MAP_BLOCK+5,		// 96
	FAN_FACING_RIGHT_MAP_BLOCK=FAN_FACING_LEFT_MAP_BLOCK+5,		// 101
	FIRST_BACKGROUND_MAP_BLOCK=FAN_FACING_RIGHT_MAP_BLOCK+5,	// 106
	LAST_BACKGROUND_MAP_BLOCK=FIRST_BACKGROUND_MAP_BLOCK+3,		// 110
	MOVING_PLATFORM_SPRITE,										// 111
	HIT_DIAMOND_SPRITE											// 112
};

enum
{
	BLOKE_MOVING_START,
	BLOKE_MOVING_END=4,
	BLOKE_STANDING_STILL,
	BLOKE_DYING_START,
	BLOKE_DYING_END=10,
	STARTING_BLOCK_DOWN,
	STARTING_BLOCK_UP,
	BAT_LEFT,
	BAT_RIGHT,
	EXPLOSION_START,
	EXPLOSION_END=25,
	BONUS_POINTS_START,
	BONUS_POINTS_END=34,
	EXTRA_LIFE_BONUS,
	EXTRA_BOMB_BONUS,
	EXTRA_TIME_BONUS,
	LEVEL_WARP_BONUS,
	X2_BONUS,
	X5_BONUS,
	X10_BONUS,
	NUMBER_BONUSES=X10_BONUS-BONUS_POINTS_START,
	LIVES_SYMBOL,
	BOMBS_SYMBOL,
	TIME_SYMBOL,
	DIAMONDS_SYMBOL
};


#endif
